#include <framebuffer.h>

int fb_write_pixel_8bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	unsigned char pixel = (((b >> 6) << 6) & 0xC0) | (((g >> 5) << 3) & 0x38) | ((r >> 5) & 0x7);
	((char*)f->device->fbaddr)[y*f->device->pixelwidth + x] = pixel;
	return 0;
}

int fb_write_pixel_16bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	unsigned int pixel = (((b >> 3) << 11) & 0xF800) | (((g >> 2) << 6) & 0x7E0) | ((r >> 3) & 0x1F);
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x) << 1] = (char)pixel;
	((char*)f->device->fbaddr)[((y*f->device->pixelwidth + x) << 1) + 1] = (char)(pixel >> 8);
	return 0;
}

int fb_write_pixel_24bit(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*4] = (char)r;
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*4 + 1] = (char)g;
	((char*)f->device->fbaddr)[(y*f->device->pixelwidth + x)*4 + 2] = (char)b;
	return 0;
}

int fb_write_pixel(struct fb *f, unsigned int x, unsigned int y, unsigned int r, unsigned int g, unsigned int b) {
	if (f->device->color_depth == FB_COLOR_DEPTH_8)
		return fb_write_pixel_8bit(f, x, y, r, g, b);
	else if (f->device->color_depth == FB_COLOR_DEPTH_16)
		return fb_write_pixel_16bit(f, x, y, r, g, b);
	else if (f->device->color_depth == FB_COLOR_DEPTH_24)
		return fb_write_pixel_24bit(f, x, y, r, g, b);
	return -1;
}
